#ifndef RTONCE_HAL_VARIANT_INC
#define RTONCE_HAL_VARIANT_INC
/*
##=============================================================================
##
##	variant.inc
##
##	Lexra family assembler header file
##
##=============================================================================
*/

/*
#include <pkgconf/hal.h>
	
#include <hal/mips.inc>

#include <hal/platform.inc>
*/

#include "../pkgconf/hal.h"
	
#include "mips.inc"

#include "platform.inc"

/* -----------------------------------------------------------------------------
## Define CPU variant for architecture HAL.
*/
#define	RT_HAL_MIPS_R3000A


/* -----------------------------------------------------------------------------
## Indicate that the ISR tables are defined in variant.S
*/
/*
#define RT_HAL_MIPS_ISR_TABLES_DEFINED
*/

/* -----------------------------------------------------------------------------
## Lexra family CPU Memory controller.
*/

#ifndef RTPKG_HAL_MIPS_MEMC_DEFINED

	.macro	hal_memc_init
	.endm


	.macro hal_memc_init_dram	
	.endm

#define RTPKG_HAL_MIPS_MEMC_DEFINED
		
#endif	

/*	
##-----------------------------------------------------------------------------
## Lexra family CPU interrupt handling.
#
# The hardware initialization has been done in OSBOOT.
# Nothing to do here.
*/




/*
#------------------------------------------------------------------------------
# Diagnostics macros.
*/	



/* ------------------------------------------------------------------------------ */
#endif // ifndef RTONCE_HAL_VARIANT_INC
/* end of variant.inc	*/
