<html>
<head>
<meta http-equiv="Content-Type" content="text/html">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">
<title>WLAN Basic Settings</title>
</head>
<SCRIPT LANGUAGE="JavaScript">

var ieee11aCh = new Array();
var ieee11aChNum = '9';
ieee11aCh[0]='Auto';
ieee11aCh[1]='36';
ieee11aCh[2]='40';
ieee11aCh[3]='44';
ieee11aCh[4]='48';
ieee11aCh[5]='52';
ieee11aCh[6]='56';
ieee11aCh[7]='60';
ieee11aCh[8]='64';

var ieee11gCh = new Array();
var ieee11gChNum = '15';
ieee11gCh[0]='Auto';
ieee11gCh[1]='1';
ieee11gCh[2]='2';
ieee11gCh[3]='3';
ieee11gCh[4]='4';
ieee11gCh[5]='5';
ieee11gCh[6]='6';
ieee11gCh[7]='7';
ieee11gCh[8]='8';
ieee11gCh[9]='9';
ieee11gCh[10]='10';
ieee11gCh[11]='11';
ieee11gCh[12]='12';
ieee11gCh[13]='13';
ieee11aCh[14]='14';

function setChannelList(domainIdx, bandIdx, chanIdx, cardIndex) {
	var chan, band, domain;
   if(cardIndex==0){
	chan = document.userform.channel0;
	  
  }else if(cardIndex==1){
	chan = document.userform.channel1;
	  
  }

  if(bandIdx == 3) { //802.11a, RTL8255 supports only chan 36~64, regardless of regulation domain.
	chan.options.length = ieee11aChNum;
	for(j = 0; j < ieee11aChNum; j++) {
	  chan.options[j] = new Option(ieee11aCh[j],j);
	}
  } else{
  	var first, last;;
	  if(domainIdx == 0) { //FCC
		first = 1;
		last = 11;
	  } else if(domainIdx == 1) { //Canada
		first = 1;
		last = 11;
	  } else if(domainIdx == 2) { //Europe
		first = 1;
		last=13;
	  } else if(domainIdx == 3) { //Spain
		first =10;
		last=11;
	  } else if(domainIdx == 4) { //France
		first = 10;
		last=13;
	  } else if(domainIdx == 5) { //japan
		first = 1;
		last=14;
	  } else if (domainIdx == 6) { //Israel
	  	first = 3;
		last = 13;
	  }
	chan.options.length = last-first+2;
	chan.options[0] = new Option(ieee11gCh[0],0);
	for(j = 1; j <= last-first+1; j++) {
		chan.options[j] = new Option(ieee11gCh[first-1+j],j);
	}
  }
	chan.selectedIndex = chanIdx;

}

function update( cardIndex){
	if(cardIndex==0){
		setChannelList(<% asp_wlanBasic("regDomain0"); %>, <% asp_wlanBasic("dataRateMode0"); %>, <% asp_wlanBasic("channel0"); %>, 0);  
	}else{
		setChannelList(<% asp_wlanBasic("regDomain1"); %>, <% asp_wlanBasic("dataRateMode1"); %>, <% asp_wlanBasic("channel1"); %>, 1);  
	}
}
function updateDomain(cardIndex){
	if(cardIndex==0){
		channel = document.userform.channel0;
		band = document.userform.dataRateMode0;
		domain = document.userform.regDomain0;
		setChannelList(domain.selectedIndex, band.selectedIndex, channel.selectedIndex, 0);  
	}else{
		channel = document.userform.channel1;
		band = document.userform.dataRateMode1;
		domain = document.userform.regDomain1;
		setChannelList(domain.selectedIndex, band.selectedIndex, channel.selectedIndex, 1);  
	}
}

function updateBand(cardIndex){
	if(cardIndex==0){
		channel = document.userform.channel0;
		band = document.userform.dataRateMode0;
		domain = document.userform.regDomain0;
		setChannelList(domain.selectedIndex, band.selectedIndex, channel.selectedIndex, 0);  
	}else{
		channel = document.userform.channel1;
		band = document.userform.dataRateMode1;
		domain = document.userform.regDomain1;
		setChannelList(domain.selectedIndex, band.selectedIndex, channel.selectedIndex, 1);  
	}
}
function onload_func()
{
  var exist0 = <% asp_wlanBasic("exist0"); %>;
  var exist1  = <% asp_wlanBasic("exist1"); %>;
	if(exist0==0)
		userform.enable0.disabled=true;
	else
		userform.enable0.disabled=false;
	if(userform.enable0.checked == false){
		userform.regDomain0.disabled=true;
		userform.name0.disabled=true;
		userform.ssid0.disabled=true;
		userform.channel0.disabled=true;
		userform.mode0.disabled=true;
		userform.version0.disabled=true;
		userform.dataRateMode0.disabled=true;
	}else{
		userform.regDomain0.disabled=false;
		userform.name0.disabled=false;
		userform.ssid0.disabled=false;
		userform.channel0.disabled=false;
		userform.mode0.disabled=false;
		userform.version0.disabled=false;
		userform.dataRateMode0.disabled=false;
		update(0);
	}


	if(exist1==0)
		userform.enable1.disabled=true;
	else
		userform.enable1.disabled=false;
	if(userform.enable1.checked == false){
		userform.name1.disabled=true;
		userform.ssid1.disabled=true;
		userform.regDomain1.disabled=true;
		userform.channel1.disabled=true;
		userform.mode1.disabled=true;
		userform.version1.disabled=true;
		userform.dataRateMode1.disabled=true;
	}else{
		userform.name1.disabled=false;
		userform.regDomain1.disabled=false;
		userform.ssid1.disabled=false;
		userform.channel1.disabled=false;
		userform.mode1.disabled=false;
		userform.version1.disabled=false;
		userform.dataRateMode1.disabled=false;
		update(1);		

	}

}



</script>
<body bgcolor="#ffffff" onload="onload_func()">
<form method="get" action="/goform/asp_setWlanBasic" name="userform">
<B>Wireless Basic Settings</b><BR>
<BR>
Wireless Card 1 <input type="checkbox" name="enable0" value=1 onClick="onload_func();" <% asp_wlanBasic("enable0"); %>>Enable<p>
<table cellSpacing=1 cellPadding=2 border=0>
  <tr><td bgColor=#aaddff>Alias Name</td>
      <td bgColor=#ddeeff><input type="text" name="name0" size=32 maxlength=32 value="<% asp_wlanBasic("name0"); %>"></td>      
  </tr>
  
  <tr><td bgColor=#aaddff>SSID</td>
      <td bgColor=#ddeeff><input type="text" name="ssid0" size=16 maxlength=16 value="<% asp_wlanBasic("ssid0"); %>"></td>
  </tr>  
  <tr><td bgColor=#aaddff>Regulation Domain</td>
      <td bgColor=#ddeeff><select  name="regDomain0" onChange="updateDomain(this.selectedIndex, 0);">
		<option value=0 <% asp_wlanBasic("regDomain0_0"); %>>FCC</option>
		<option value=1 <% asp_wlanBasic("regDomain0_1"); %>>IC(Canada)</option>
		<option value=2 <% asp_wlanBasic("regDomain0_2"); %>>ETSI(Europe)</option>
		<option value=3 <% asp_wlanBasic("regDomain0_3"); %>>Spain</option>
		<option value=4 <% asp_wlanBasic("regDomain0_4"); %>>France</option>
		<option value=5 <% asp_wlanBasic("regDomain0_5"); %>>MKK(Japan)</option>
		<option value=6 <% asp_wlanBasic("regDomain0_6"); %>>Israel</option>
      </td>
  </tr>
  <tr><td bgColor=#aaddff>RF Band</td>
      <td bgColor=#ddeeff><select  name="dataRateMode0" onChange="updateBand(this.selectedIndex, 0);">
		<option value=0 <% asp_wlanBasic("dataRateMode0_0"); %>>802.11b only</option>
		<option value=1 <% asp_wlanBasic("dataRateMode0_1"); %>>802.11g</option>
		<option value=2 <% asp_wlanBasic("dataRateMode0_2"); %>>802.11b+g</option>
		<option value=3 <% asp_wlanBasic("dataRateMode0_3"); %>>802.11a</option>
      </td>
  </tr> 
  <tr><td bgColor=#aaddff>Channel Number</td>
      <td bgColor=#ddeeff>
      		<select name="channel0" >
		</select>
      </td>
  </tr> 
  <tr>
      <td bgColor=#aaddff>Operation Mode</td>
      <td><select name="mode0">
		<option value=0 <% asp_wlanBasic("mode0_0"); %>>AP</option>
		<option value=1 <% asp_wlanBasic("mode0_1"); %>>client</option>
		<option value=2 <% asp_wlanBasic("mode0_2"); %>>WDS</option>
		<option value=3 <% asp_wlanBasic("mode0_3"); %>>AP+WDS</option>
	 </select>
      </td>
  </tr>  
 <tr><td bgColor=#aaddff>Chip ID (Engineering)</td>
      <td bgColor=#ddeeff><select name="version0">
		<option value=0 <% asp_wlanBasic("ver0_0"); %>>Zebra(B), 8185(B, 412+)</option>
		<option value=1 <% asp_wlanBasic("ver0_1"); %>>Zebra(A), 8185(C, 425+)</option>
		<option value=2 <% asp_wlanBasic("ver0_2"); %>>Zebra(B), 8185(C, 425+)</option>
		<option value=3 <% asp_wlanBasic("ver0_3"); %>>Zebra(C), 8185(D, 435+)</option>
		<option value=4 <% asp_wlanBasic("ver0_4"); %>>OMC(A), 8185(D, 435+)</option>
	</td>		
  </tr>
 
  </table>

<BR>
Wireless Card 2<input type="checkbox" name="enable1" value=1 onClick="onload_func();" <% asp_wlanBasic("enable1"); %>>Enable<p>
<table cellSpacing=1 cellPadding=2 border=0 >
  <tr><td bgColor=#aaddff>Alias Name</td>
      <td bgColor=#ddeeff><input type="text" name="name1" size=32 maxlength=32 value="<% asp_wlanBasic("name1"); %>"></td>      
  </tr>
  
  <tr><td bgColor=#aaddff>SSID</td>
      <td bgColor=#ddeeff><input type="text" name="ssid1" size=16 maxlength=16 value="<% asp_wlanBasic("ssid1"); %>"></td>
  </tr>  
  <tr><td bgColor=#aaddff>Regulation Domain</td>
      <td bgColor=#ddeeff><select  name="regDomain1" onChange="updateDomain(this.selectedIndex, 1);">
		<option value=0 <% asp_wlanBasic("regDomain1_0"); %>>FCC</option>
		<option value=1 <% asp_wlanBasic("regDomain1_1"); %>>IC(Canada)</option>
		<option value=2 <% asp_wlanBasic("regDomain1_2"); %>>ETSI(Europe)</option>
		<option value=3 <% asp_wlanBasic("regDomain1_3"); %>>Spain</option>
		<option value=4 <% asp_wlanBasic("regDomain1_4"); %>>France</option>
		<option value=5 <% asp_wlanBasic("regDomain1_5"); %>>MKK(Japan)</option>
		<option value=6 <% asp_wlanBasic("regDomain1_6"); %>>Israel</option>
	</td>
  </tr>
  <tr><td bgColor=#aaddff>RF Band</td>
      <td bgColor=#ddeeff><select  name="dataRateMode1" onChange="updateBand(this.selectedIndex, 1);">
		<option value=0 <% asp_wlanBasic("dataRateMode1_0"); %>>802.11b only</option>
		<option value=1 <% asp_wlanBasic("dataRateMode1_1"); %>>802.11g</option>
		<option value=2 <% asp_wlanBasic("dataRateMode1_2"); %>>802.11b+g</option>
		<option value=3 <% asp_wlanBasic("dataRateMode1_3"); %>>802.11a</option>
      </td>
  </tr>   
 <tr><td bgColor=#aaddff>Channel Number</td>
      <td bgColor=#ddeeff>
      		<select name="channel1" >
		</select>
      </td>
  </tr> 
  <tr>
      <td bgColor=#aaddff>Operation Mode</td>
      <td><select name="mode1">
		<option value=0 <% asp_wlanBasic("mode1_0"); %>>AP</option>
		<option value=1 <% asp_wlanBasic("mode1_1"); %>>client</option>
		<option value=2 <% asp_wlanBasic("mode1_2"); %>>WDS</option>
		<option value=3 <% asp_wlanBasic("mode1_3"); %>>AP+WDS</option>
	 </select>
      </td>
  </tr>
  <tr><td bgColor=#aaddff>Chip ID (Engineering)</td>
      <td bgColor=#ddeeff><select name="version1">
		<option value=0 <% asp_wlanBasic("ver1_0"); %>>Zebra(B), 8185(B, 412+)</option>
		<option value=1 <% asp_wlanBasic("ver1_1"); %>>Zebra(A), 8185(C, 425+)</option>
		<option value=2 <% asp_wlanBasic("ver1_2"); %>>Zebra(B), 8185(C, 425+)</option>
		<option value=3 <% asp_wlanBasic("ver1_3"); %>>Zebra(C), 8185(D, 435+)</option>
		<option value=4 <% asp_wlanBasic("ver1_4"); %>>OMC(A), 8185(D, 435+)</option>
	</td>
  </tr>


 <tr><Td colspan=2 align=center>
     <input type="submit" name="save" value="Apply">&nbsp;&nbsp;&nbsp;&nbsp;
     <input type="reset" value="Reset" name="reset">
  </tr>
</table>

























</form>
</body>
</html>
