<html>
<head>
<meta http-equiv="Content-Type" content="text/html">
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Cache-Control" CONTENT="no-cache">
<script language="javascript">


/* ==================================== Cryption Sub ==================================== */
var wep_sub = new Array();
var wep_sub_len = '2';
wep_sub[0]='64 bits';
wep_sub[1]='128 bits';

var wpa_sub = new Array();
var wpa_sub_len = '3';
wpa_sub[0]='TKIP';
wpa_sub[1]='AES';
wpa_sub[2]='BOTH';

var wpa_mix_sub = new Array();
var wpa_mix_sub_len = '5';
wpa_mix_sub[0]='WPA1(TKIP) WPA2(TKIP)';
wpa_mix_sub[1]='WPA1(TKIP) WPA2(AES)';
wpa_mix_sub[2]='WPA1(AES) WPA2(TKIP)';
wpa_mix_sub[3]='WPA1(AES) WPA2(AES)';
wpa_mix_sub[4]='WPA1(BOTH) WPA2(BOTH)';

/* ==================================== Authentication ==================================== */

/* 0 */
var open = new Array();
var open_len = '2';
open[0]='No authentication';
open[1]='By RADIUS server';

/* 1 */
var wep = new Array();
var wep_len = '4';
wep[0]='Open system';
wep[1]='Shared key';
wep[2]='Auto (Open system/Shared key)';
wep[3]='By RADIUS server';

/* 2 / 3 / 4 */
var wpa = new Array();
var wpa_len = '2';
wpa[0]='pre-shared key';
wpa[1]='By RADIUS server';

/* record the 'Radius' option's index of each cryptType */
var radiusIdx = new Array();
radiusIdx[0]="1";					/* no encryption */
radiusIdx[1]="3";					/* WEP */
radiusIdx[2]="1";					/* WPA */
radiusIdx[3]="1";					/* WPA2 */
radiusIdx[4]="1";					/* WPA-MIX */

/* record the 'no auth' option's index of each crypType */
var noAuthIdx = new Array();
noAuthIdx[0]="0";					/* no encryption */
noAuthIdx[1]="-1";					/* WEP */
noAuthIdx[2]="-1";					/* WPA */
noAuthIdx[3]="-1";					/* WPA2 */
noAuthIdx[4]="-1";					/* WPA-MIX */

function setAuth (cryptIdx, cardIndex)
{
	if (cardIndex == 0)
	{
		crypt = document.userform.cryptType0;
		auth = document.userform.authType0;
		key = window.defKey0.style;
		radius = window.radiusSetting0.style;
  	}else if(cardIndex == 1)
 	{
		crypt = document.userform.cryptType1;
		auth = document.userform.authType1;
		key = window.defKey1.style;
		radius = window.radiusSetting1.style;
	}

	switch ( cryptIdx )
	{
		case 0:
			/* no encryption */
			auth.options.length = open_len;
			for ( i = 0 ; i < open_len ; i ++ )
			{
				auth.options[i] = new Option(open[i], i);
			}
			break;

		case 1:
			/* WEP */
			auth.options.length = wep_len;
			for ( i = 0 ; i < wep_len ; i ++ )
			{
				auth.options[i] = new Option(wep[i], i);
			}
			break;

		case 2:
			/* WPA */
		case 3:
			/* WPA2 */
		case 4:
			/* WPA-MIX */
			auth.options.length = wpa_len;
			for ( i = 0 ; i < wpa_len ; i ++ )
			{
				auth.options[i] = new Option(wpa[i], i);
			}
			break;
		default:
			break;
	}

	key.display = "none";
	radius.display = "none";
}

function setCryptSubType (cryptIdx, cardIndex)
{
	if (cardIndex == 0)
	{
		crypt = document.userform.cryptType0;
		cryptSub = document.userform.cryptSubType0;
		cryptSubStyle = window.cryptSubTypeSet0.style;
  	}else if(cardIndex == 1)
 	{
		crypt = document.userform.cryptType1;
		cryptSub = document.userform.cryptSubType1;
		cryptSubStyle = window.cryptSubTypeSet1.style;
	}

	/* always disable crypt-sub setting */
	cryptSubStyle.display = "none";

	switch ( cryptIdx )
	{
		case 0:
			/* no encryption */
			cryptSub.options.length = 0;
 			break;

		case 1:
			/* WEP */

			/* enable sub-type setting */
			cryptSubStyle.display = "";
			/* set option */
			cryptSub.options.length = wep_sub_len;
			for ( i = 0 ; i < wep_sub_len ; i ++ )
			{
				cryptSub.options[i] = new Option(wep_sub[i], i);
			}
			break;

		case 2:
			/* WPA */
		case 3:
			/* WPA2 */

			/* enable sub-type setting */
			cryptSubStyle.display = "";
			/* set option */
			cryptSub.options.length = wpa_sub_len;
			for ( i = 0 ; i < wpa_sub_len ; i ++ )
			{
				cryptSub.options[i] = new Option(wpa_sub[i], i);
			}
			break;

		case 4:
			/* WPA-MIX */

			/* enable sub-type setting */
			cryptSubStyle.display = "";
			/* set option */
			cryptSub.options.length = wpa_mix_sub_len;
			for ( i = 0 ; i < wpa_mix_sub_len ; i ++ )
			{
				cryptSub.options[i] = new Option(wpa_mix_sub[i], i);
			}
			break;

		default:
			break;
	}
}

function setKeyRadius(authIdx, cryptIdx, cardIndex)
{
	if (cardIndex==0)
 	{
		crypt = document.userform.cryptType0;
		auth = document.userform.authType0;
		key = window.defKey0.style;
		radius = window.radiusSetting0.style;
	}else if( cardIndex==1)
	{
		crypt = document.userform.cryptType1;
		auth = document.userform.authType1;
		key = window.defKey1.style;
		radius = window.radiusSetting1.style;
	}

	key.display = "none";
	radius.display = "none";

 	if (noAuthIdx[cryptIdx] == authIdx)
 	{	/* no auth need to display, including KEY and RADIUS */
		key.display = "none";
		radius.display = "none";
	}
	else if (radiusIdx[cryptIdx] == authIdx)
	{	/* show RADIUS setting, don't show KEY setting */
		key.display = "none";
		radius.display = "";
	}
	else
	{	/* show KEY setting, don't show RADIUS setting */
 	 	key.display = "";
		radius.display = "none";
	}
}

function setCryptSubAuthKeyRadius(authIdx, cryptIdx, cardIndex)
{
	setCryptSubType(cryptIdx, cardIndex);
	setAuth(cryptIdx, cardIndex);
	setKeyRadius(authIdx, cryptIdx, cardIndex);
}


function loadDefault()
{
	var exist0 = <% asp_wlanBasic("exist0"); %>;
	var exist1 = <% asp_wlanBasic("exist1"); %>;
 
	/* WLAN card 0 */
	if (exist0==1)
	{
		userform.cryptType0.disabled=false;
		userform.cryptSubType0.disabled=false;
		userform.authType0.disabled=false;

		model = document.userform.encryption0;
		auth = document.userform.authType0;
		crypt = document.userform.cryptType0;
		cryptSub = document.userform.cryptSubType0;

		crypt.selectedIndex = <% asp_wlanSecurity("cryptType0"); %>;
		setAuth(crypt.selectedIndex, 0);
		setCryptSubType(crypt.selectedIndex, 0);
		cryptSub.selectedIndex = <% asp_wlanSecurity("cryptSubType0"); %>;
		auth.selectedIndex = <% asp_wlanSecurity("authType0"); %>;
		setKeyRadius(auth.selectedIndex,crypt.selectedIndex, 0);
	}else
	{
		userform.cryptType0.disabled=true;
		userform.cryptSubType0.disabled=true;
		userform.authType0.disabled=true;
	}

	/* WLAN card 1 */
	if (exist1==1)
	{
		userform.cryptType1.disabled=false;
		userform.cryptSubType1.disabled=false;
		userform.authType1.disabled=false;

		model = document.userform.encryption1;
		auth = document.userform.authType1;
		crypt = document.userform.cryptType1;
		cryptSub = document.userform.cryptSubType1;

		crypt.selectedIndex = <% asp_wlanSecurity("cryptType1"); %>;
		setAuth(crypt.selectedIndex, 1);
		setCryptSubType(crypt.selectedIndex, 1);
		cryptSub.selectedIndex = <% asp_wlanSecurity("cryptSubType1"); %>;
		auth.selectedIndex = <% asp_wlanSecurity("authType1"); %>;
		setKeyRadius(auth.selectedIndex,crypt.selectedIndex, 1);
	}else
	{
		userform.cryptType1.disabled=true;
		userform.cryptSubType1.disabled=true;
		userform.authType1.disabled=true;
	}
}


</script>
<title>Wireless Security Setup</title>
</head>
<body bgcolor="#ffffff">

<B>Wireless Security Setup</b><BR>
<BR>
<form method="post" action="/goform/asp_setWlanSecurity" name="userform">
	<table cellSpacing=1 cellPadding=2 border=0 <% asp_wlanBasic("show0"); %>>
		<tr>
			<td bgcolor=#ddffaa>Interface '<% asp_wlanSecurity("alias0"); %>'</td>
		</tr>
		<tr>
			<td bgColor=#aaddff>Data encryption</td>
			<td bgColor=#ddeeff>
				<select name="cryptType0" onClick="setCryptSubAuthKeyRadius(document.userform.authType0.selectedIndex,this.selectedIndex, 0);" <% asp_wlanBasic("show0"); %>>
					<option value=0>No encryption</option>
					<option value=1>WEP</option>
					<option value=2>WPA</option>
					<option value=3>WPA2</option>
					<option value=4>WPA - AUTO</option>
				</select>
			</td>
		</tr>

		<tr id="cryptSubTypeSet0" STYLE="display:none;">
			<td bgColor=#aaddff>method</td>
			<td bgColor=#ddeeff>
				<select name="cryptSubType0" <% asp_wlanBasic("show0"); %>>
				<option selected <% asp_wlanBasic("show0"); %>>None</option></select>
			</td>
		</tr>

		<tr>
			<td bgColor=#aaddff>Authentication</td>
			<td bgColor=#ddeeff>
				<select name="authType0" onClick="setKeyRadius(this.selectedIndex,crypt.selectedIndex, 0);" <% asp_wlanBasic("show0"); %>>
				<option selected <% asp_wlanBasic("show0"); %>>No authentication</option></select>
			</td>
		</tr>

		<tr id="defKey0" STYLE="display:none;">
			<td bgColor=#aaddff>Key setting</td>
			<td bgColor=#ddeeff><input type="password" name="key0" size=32 maxlength=64 value="<% asp_wlanSecurity("key0"); %>" <% asp_wlanBasic("show0"); %>><br>
			<% asp_wlanSecurity("keyType0"); %></td>
		</tr>

		<tr>
		</tr>

		<tr id="radiusSetting0" STYLE="display:none;">
			<td bgColor=#aaddff>RADIUS Setting</td>
			<td bgColor=#ddeeff>
				<table>
					<tr><Td>Port:</td><td><input type="text" name="port0" size=5 <% asp_wlanBasic("show0"); %> maxlength=5 value="<% asp_wlanSecurity("port0"); %>"></td></tr>
					<tr><td>IP Address:</td><td><input type="text" name="ipaddr0" size=15 <% asp_wlanBasic("show0"); %> maxlength=15 value="<% asp_wlanSecurity("ipaddr0"); %>"></td></tr>
					<tr><td>Password:</td><td><input type="password" name="passwd0" size=15 <% asp_wlanBasic("show0"); %> maxlength=16  value="<% asp_wlanSecurity("passwd0"); %>"></td></tr>
				</table>
			</td>      
		</tr>
	</table>


 	<table cellSpacing=1 cellPadding=2 border=0 <% asp_wlanBasic("show1"); %>>
		<tr>
			<td bgcolor=#ddffaa>Interface '<% asp_wlanSecurity("alias1"); %>'</td>
		</tr>

		<tr>
			<td bgColor=#aaddff>Data encryption</td>
			<td bgColor=#ddeeff>
				<select name="cryptType1" onClick="setCryptSubAuthKeyRadius(document.userform.authType1.selectedIndex,this.selectedIndex, 1);" <% asp_wlanBasic("show1"); %>>
					<option value=0>No encryption</option>
					<option value=1>WEP</option>
					<option value=2>WPA</option>
					<option value=3>WPA2</option>
					<option value=4>WPA - AUTO</option>
				</select>
			</td>
		</tr>

		<tr id="cryptSubTypeSet1" STYLE="display:none;">
			<td bgColor=#aaddff>method</td>
			<td bgColor=#ddeeff>
				<select name="cryptSubType1" <% asp_wlanBasic("show1"); %>>
				<option selected <% asp_wlanBasic("show1"); %>>None</option></select>
			</td>
		</tr>


		<tr>
			<td bgColor=#aaddff>Authentication</td>
			<td bgColor=#ddeeff>
				<select name="authType1" onClick="setKeyRadius(this.selectedIndex,crypt.selectedIndex, 1);" <% asp_wlanBasic("show1"); %>>
				<option selected <% asp_wlanBasic("show1"); %>>No authentication</option>
				</select>
			</td>
		</tr>

		<tr id="defKey1" STYLE="display:none;">
			<td bgColor=#aaddff>Key setting</td>
			<td bgColor=#ddeeff><input type="password" name="key1" size=32 maxlength=64 value="<% asp_wlanSecurity("key1"); %>" <% asp_wlanBasic("show1"); %>><br>
			<% asp_wlanSecurity("keyType1"); %></td>
		</tr>

		<tr>
		</tr>

		<tr id="radiusSetting1" STYLE="display:none;">
			<td bgColor=#aaddff>RADIUS Setting</td>
			<td bgColor=#ddeeff>
				<table>
					<tr>
						<Td>Port:</td><td><input type="text" name="port1" size=5 <% asp_wlanBasic("show1"); %> maxlength=5 value="<% asp_wlanSecurity("port1"); %>"></td>
					</tr>

					<tr>
						<td>IP Address:</td>
						<td><input type="text" name="ipaddr1" size=15 <% asp_wlanBasic("show1"); %> maxlength=15 value="<% asp_wlanSecurity("ipaddr1"); %>"></td>
					</tr>

					<tr>
						<td>Password:</td>
						<td><input type="password" name="passwd1" size=15 <% asp_wlanBasic("show1"); %> maxlength=16  value="<% asp_wlanSecurity("passwd1"); %>"></td>
					</tr>
				</table>
			</td>      
		</tr>
	</table>

	<table <% asp_wlanBasic("showEach"); %>>
		<tr>
			<Td colspan=2 align=center>
				<input type="submit" name="save" value="Apply">&nbsp;&nbsp;&nbsp;&nbsp;
				<input type="reset" value="Reset" name="reset">
		</tr>
	</table>

	<script language=javascript>
		loadDefault();
	</script>
</form>
</body>
</html>
